import Vue from 'vue';
import { ReadonlyPropertyDescriptor } from './util';
export declare type Lifecycles = 'beforeCreate' | 'created' | 'beforeDestroy' | 'destroyed' | 'beforeMount' | 'mounted' | 'beforeUpdate' | 'updated' | 'activated' | 'deactivated';
export declare type BeforeRouteUpdateLifecycle = 'beforeRouteUpdate';
export declare type BeforeRouteLeaveLifecycle = 'beforeRouteLeave';
export declare type BeforeRouteEnterLifecycle = 'beforeRouteEnter';
export declare type NextFuncVmCallback<T extends Vue> = (vm: T) => void;
export declare type NextFunc = () => void;
export declare type NextFuncBool = (ok?: false) => void;
export declare type NextFuncVm<T extends Vue = any> = (next?: NextFuncVmCallback<T>) => void;
export declare type BeforeRouteUpdateHandler = (to: any, from: any, next: NextFunc) => void;
export declare type BeforeRouteLeaveHandler = (to: any, from: any, next: NextFuncBool) => void;
export declare type BeforeRouteEnterHandler = (to: any, from: any, next: NextFuncVm) => void;
export declare function Lifecycle(target: Vue, life: Lifecycles, _: ReadonlyPropertyDescriptor<() => void>): void;
export declare function Lifecycle(target: Vue, life: BeforeRouteUpdateLifecycle, _: ReadonlyPropertyDescriptor<BeforeRouteUpdateHandler>): void;
export declare function Lifecycle(target: Vue, life: BeforeRouteLeaveLifecycle, _: ReadonlyPropertyDescriptor<BeforeRouteLeaveHandler>): void;
export declare function Lifecycle(target: Vue, life: BeforeRouteEnterLifecycle, _: ReadonlyPropertyDescriptor<BeforeRouteEnterHandler>): void;
